%define         _disable_ld_no_undefined 0

%define         major                    20

%define         cxx_major                20
#define         usempi_major             12
%define         usempif08_major          %{major}
%define         usempi_ignore_major      %{major}
%define         mpifh_major              %{major}
#define         vt_major                 0
%define         ompitrace_major          %{major}
%define         opentrace_major          %{major}
%define         openpal_major            %{major}
%define         openrte_major            %{major}
#define         otfaux_major             0
%define         oshmem_major             %{major}

%define         libname                  %mklibname %{name} %{major}
%define         develname                %mklibname %{name} -d
%define         staticdevelname          %mklibname %{name} -s -d

%define         gccinstalldir   %(LC_ALL=C %__cc --print-search-dirs | %__grep install | %__awk '{print $2}')
%define         fincludedir     %{gccinstalldir}finclude


Summary:        An implementation of the Message Passing Interface
Name:           openmpi
Version:        2.1.0
Release:        %mkrel 3
License:        BSD
Group:          Development/Other

URL:            http://www.open-mpi.org
Source0:        http://www.open-mpi.org/software/ompi/v1.10/downloads/openmpi-%{version}.tar.bz2
Patch0:         ompi_autogen_sh.patch
Patch1:         arm_detection.diff
Patch2:         openmpi-1.10.1-fix-function-if.patch

BuildRequires:  bison
BuildRequires:  flex
BuildRequires:  gawk
BuildRequires:  pkgconfig(pkg-config)
BuildRequires:  gcc-gfortran
%ifarch %ix86 x86_64
BuildRequires:  java-openjdk
BuildRequires:  quadmath-devel
BuildRequires:  librdmacm-devel
%endif
BuildRequires:  gcc-c++
BuildRequires:  binutils-devel
BuildRequires:  libibverbs-devel
BuildRequires:  libgomp-devel
BuildRequires:  torque-devel >= 2.3.7
BuildRequires:  pkgconfig(zlib)
BuildRequires:  pkgconfig(hwloc)
BuildRequires:  hwloc
BuildRequires:  autoconf

Requires:       %{libname} = %{version}-%{release}
Recommends:       %{develname} = %{version}-%{release}

Conflicts:      mpich
Conflicts:      mpich2
Conflicts:      lam


%description
The Open MPI Project is an open source fully compliant MPI-3
implementation that is developed and maintained by a consortium of
academic, research, and industry partners. OpenMPI is therefore able
to combine the expertise, technologies, and resources from all across
the High Performance Computing community in order to build the best
MPI library available. OpenMPI offers advantages for system and
software vendors, application developers and computer science
researchers. This package contains all of the tools necessary to
compile, link, and run OpenMPI jobs.



%package -n %{libname}
Summary:        Shared libraries for OpenMPI
Group:          Development/Other
Provides:       lib%{name} = %{version}-%{release}
Obsoletes:      %{_lib}openmpi0 <= 1.5
# Build with wrong major:
Obsoletes:      %{_lib}openmpi1 < 1.10.0-2

%description -n %{libname}
%{summary}.



%package -n %{develname}
Summary:        Development files for OpenMPI
Group:          Development/Other
Requires:       %{libname} = %{version}-%{release}
#was Requires
Recommends:       %{name} = %{version}-%{release}
Requires:       gcc-gfortran 
Requires:       gcc-c++
Provides:       lib%{name}-devel  = %{version}-%{release}
Provides:       %{name}-devel = %{version}-%{release}
Conflicts:      lam-devel
Conflicts:      mpich1-devel
Conflicts:      mpich2-devel

%description -n %{develname}
%{summary}.



%package -n %{staticdevelname}
Summary:        Static Development files for OpenMPI
Group:          Development/Other
Requires:       %{libname} = %{version}-%{release}
Requires:       gcc-gfortran 
Requires:       gcc-c++
Provides:       lib%{name}-static-devel  = %{version}-%{release}
Provides:       %{name}-static-devel = %{version}-%{release}
Conflicts:      lam-devel
Conflicts:      mpich1-devel
Conflicts:      mpich2-devel

%description -n %{staticdevelname}
%{summary}.



%prep
%setup -q
#apply_patches
#./autogen.sh
#patch2 -p1

%build
%configure2_5x --enable-shared \
	--enable-static \
	--disable-wrapper-rpath \
	--enable-mpi-cxx \
%ifnarch armv5tl
               --enable-mpi-thread-multiple \
%endif
               --with-threads=posix \
               --with-tm \
               --with-hwloc=%{_prefix}

%make


%install
%makeinstall_std

%__rm -rf %{buildroot}%{_sysconfdir}/openmpi-totalview.tcl
%__rm -rf %{buildroot}%{_datadir}/libtool
%__rm -f %{buildroot}%{_datadir}/config.log
%__rm -f %{buildroot}%{_datadir}/omp.h


%__install -D -m 644 %{buildroot}%{_libdir}/mpi.mod %{buildroot}%{fincludedir}/mpi.mod
%__install -D -m 644 %{buildroot}%{_libdir}/mpi_ext.mod %{buildroot}%{fincludedir}/mpi_ext.mod
%__install -D -m 644 %{buildroot}%{_libdir}/mpi_f08.mod %{buildroot}%{fincludedir}/mpi_f08.mod
%__install -D -m 644 %{buildroot}%{_libdir}/mpi_f08_ext.mod %{buildroot}%{fincludedir}/mpi_f08_ext.mod
%__install -D -m 644 %{buildroot}%{_libdir}/mpi_f08_interfaces.mod %{buildroot}%{fincludedir}/mpi_f08_interfaces.mod
%__install -D -m 644 %{buildroot}%{_libdir}/mpi_f08_interfaces_callbacks.mod %{buildroot}%{fincludedir}/mpi_f08_interfaces_callbacks.mod
#__install -D -m 644 %%{buildroot}%%{_libdir}/mpi_f08_sizeof.mod %%{buildroot}%%{fincludedir}/mpi_f08_sizeof.mod
%__install -D -m 644 %{buildroot}%{_libdir}/mpi_f08_types.mod %{buildroot}%{fincludedir}/mpi_f08_types.mod
%__install -D -m 644 %{buildroot}%{_libdir}/pmpi_f08_interfaces.mod %{buildroot}%{fincludedir}/pmpi_f08_interfaces.mod
%__rm %{buildroot}%{_libdir}/*.mod
pushd %{buildroot}%{_libdir}
%__ln_s %{fincludedir}/*.mod  .
popd

find %{buildroot}%{_libdir} -name *.la -delete



%files
%doc README LICENSE NEWS AUTHORS
%config(noreplace) %{_sysconfdir}/*
%{_bindir}/mpirun
%{_bindir}/mpiexec
%{_bindir}/orted
%{_bindir}/orte-*
%{_bindir}/orterun
%{_bindir}/ompi-*
#{_bindir}/otf*
%{_bindir}/osh*
%{_bindir}/shmem*
%{_datadir}/%{name}/*.txt
%{_datadir}/%{name}/amca*
%{_datadir}/%{name}/*.supp
%{_datadir}/%{name}/mca*
%{_mandir}/man1/mpirun*
%{_mandir}/man1/mpiexec*
%{_mandir}/man1/orte*
%{_mandir}/man1/osh*
%{_mandir}/man1/shmem*
%{_mandir}/man1/ompi-*
%{_mandir}/man7/*


#may be splitted at some point
%files -n %{libname} 
#doc %{_datadir}/%{name}/doc/COPYRIGHT-ptmalloc2.txt
%{_libdir}/libmpi.so.%{major}{,.*}
#%{_libdir}/libmpi_c*.so.%{cxx_major}{,.*}
#%{_libdir}/libmpi_usempi.so.#{usempi_major}
%{_libdir}/libmpi_cxx.so.%{cxx_major}{,.*}
%{_libdir}/libmpi_usempif08.so.%{usempif08_major}{,.*}
%{_libdir}/libmpi_usempi_ignore*.so.%{usempi_ignore_major}{,.*}
%{_libdir}/libmpi_mpifh*.so.%{mpifh_major}{,.*}
#{_libdir}/libvt*.so.%{vt_major}{,.*}
%{_libdir}/libompitrace*.so.%{ompitrace_major}{,.*}
#{_libdir}/libopen-trace*.so.%{opentrace_major}{,.*}
%{_libdir}/libopen-pal*.so.%{openpal_major}{,.*}
%{_libdir}/libopen-rte*.so.%{openrte_major}{,.*}
#{_libdir}/libotfaux*.so.%{otfaux_major}{,.*}
%{_libdir}/liboshmem*.so.%{oshmem_major}{,.*}


%files -n %{develname}
%doc examples/
#doc %{_datadir}/vampirtrace
%{_bindir}/mpif*
%{_bindir}/mpic*
%{_bindir}/mpiC*
%{_bindir}/ortec*
%{_bindir}/opal*
#{_bindir}/opari*
#{_bindir}/vt*
%{_bindir}/ompi_*
%{_includedir}/*
%{_libdir}/*.so
%{_libdir}/%{name}/*.so
%{_libdir}/*.mod
%{fincludedir}/*.mod
%{_libdir}/pkgconfig/*.pc
%{_datadir}/%{name}/mpi*
%{_mandir}/man1/mpif*
%{_mandir}/man1/mpic*
%{_mandir}/man1/mpiC*
%{_mandir}/man1/ompi_*
%{_mandir}/man1/opal_wrapper*
%{_mandir}/man3/*



%files -n %{staticdevelname}
%{_libdir}/*.a
%{_libdir}/%{name}/*.a


%changelog
* Wed May 03 2017 eatdirt <eatdirt> 2.1.0-3.mga6
+ Revision: 1098776
- Rebuild for new hwloc and torque

* Thu Apr 06 2017 ghibo <ghibo> 2.1.0-2.mga6
+ Revision: 1096051
- Enable cxx stuff, otherwise mpicxx can't compile .cxx programs.

* Mon Apr 03 2017 eatdirt <eatdirt> 2.1.0-1.mga6
+ Revision: 1095789
- Upgrade to version 2.1.0

* Tue Mar 07 2017 eatdirt <eatdirt> 2.0.2-2.mga6
+ Revision: 1089504
- Rebuild for new hwloc

* Tue Feb 07 2017 eatdirt <eatdirt> 2.0.2-1.mga6
+ Revision: 1085090
- Upgrade to bug fix release 2.0.2

* Thu Dec 08 2016 eatdirt <eatdirt> 2.0.1-2.mga6
+ Revision: 1073151
- Disabling -rpath in mpiXX wrappers

* Thu Dec 01 2016 eatdirt <eatdirt> 2.0.1-1.mga6
+ Revision: 1071483
- Upgrade to version 2.0.1

* Sun Sep 25 2016 ghibo <ghibo> 1.10.4-1.mga6
+ Revision: 1056035
- Update to maintenance release 1.10.4

* Mon Jun 27 2016 eatdirt <eatdirt> 1.10.3-3.mga6
+ Revision: 1037932
- Fix arm build

* Mon Jun 27 2016 eatdirt <eatdirt> 1.10.3-2.mga6
+ Revision: 1037753
- Switching on RDMA support (adding dep to librdmarc)

* Fri Jun 24 2016 eatdirt <eatdirt> 1.10.3-1.mga6
+ Revision: 1037454
- Upgrade to bugfix release 1.10.3

* Mon Jan 25 2016 luigiwalser <luigiwalser> 1.10.2-1.mga6
+ Revision: 927242
- 1.10.2

* Tue Dec 15 2015 pterjan <pterjan> 1.10.1-3.mga6
+ Revision: 910591
- Fix build on armv5 by disabling mpi-thread-multiple

* Sat Dec 12 2015 neoclust <neoclust> 1.10.1-2.mga6
+ Revision: 909751
- Add testing patch provided by pterjan to allow build on armv5

* Sun Nov 22 2015 eatdirt <eatdirt> 1.10.1-1.mga6
+ Revision: 904918
- Upgrade to version 1.10.1

* Fri Oct 09 2015 barjac <barjac> 1.10.0-5.mga6
+ Revision: 888226
- Really obsolete rpm built with wrong major

* Thu Oct 08 2015 barjac <barjac> 1.10.0-4.mga6
+ Revision: 887422
- Obsolete lib built with wrong major version

* Thu Oct 08 2015 barjac <barjac> 1.10.0-3.mga6
+ Revision: 887418
- revert previous removal of all instances of {,.*} to better trap major changes

* Thu Oct 08 2015 barjac <barjac> 1.10.0-2.mga6
+ Revision: 887414
- fix major

* Tue Sep 29 2015 eatdirt <eatdirt> 1.10.0-1.mga6
+ Revision: 885218
- Upgrade to latest stable version 1.10.0

* Sun Aug 16 2015 eatdirt <eatdirt> 1.8.8-1.mga6
+ Revision: 865184
- Upgrade to version 1.8.8

* Fri Jan 30 2015 eatdirt <eatdirt> 1.8.4-1.mga5
+ Revision: 812738
- Upgrade to version 1.8.4

* Wed Oct 15 2014 umeabot <umeabot> 1.8.3-2.mga5
+ Revision: 746188
- Second Mageia 5 Mass Rebuild

  + eatdirt <eatdirt>
    - Upgrade to the bugfix release 1.8.3

* Tue Sep 16 2014 umeabot <umeabot> 1.8.2-2.mga5
+ Revision: 683225
- Mageia 5 Mass Rebuild

  + tv <tv>
    - s/uggests:/Recommends:/

* Wed Sep 03 2014 eatdirt <eatdirt> 1.8.2-1.mga5
+ Revision: 671310
- Upgrade to version 1.8.2

* Mon Apr 28 2014 eatdirt <eatdirt> 1.8.1-1.mga5
+ Revision: 618723
- Upgrade to version 1.8.1

* Thu Apr 10 2014 eatdirt <eatdirt> 1.8-1.mga5
+ Revision: 613198
- Upgrade to latest stable version 1.8

* Sat Oct 19 2013 umeabot <umeabot> 1.6.5-2.mga4
+ Revision: 529949
- Mageia 4 Mass Rebuild

* Mon Jul 15 2013 eatdirt <eatdirt> 1.6.5-1.mga4
+ Revision: 454402
- Upgrade to version 1.6.5 (stable release)

* Mon May 27 2013 eatdirt <eatdirt> 1.6.4-2.mga4
+ Revision: 428975
- Rebuilt for latest hwloc

* Thu Feb 28 2013 rtp <rtp> 1.6.4-1.mga3
+ Revision: 400694
- update to 1.6.4
- merge arm fixes from Debian

* Sun Jan 13 2013 umeabot <umeabot> 1.6.3-3.mga3
+ Revision: 362051
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Tue Jan 08 2013 eatdirt <eatdirt> 1.6.3-2.mga3
+ Revision: 343238
- Rebuild for new hwloc

* Sat Nov 03 2012 eatdirt <eatdirt> 1.6.3-1.mga3
+ Revision: 312732
- Upgrading to version 1.6.3

* Sat Sep 01 2012 eatdirt <eatdirt> 1.6.1-3.mga3
+ Revision: 287072
- Rebuild for hwloc library

* Sat Aug 25 2012 eatdirt <eatdirt> 1.6.1-2.mga3
+ Revision: 283838
- Rebuild for torque 2.5.12, weakening deps

* Thu Aug 23 2012 eatdirt <eatdirt> 1.6.1-1.mga3
+ Revision: 283302
- Upgrade to version 1.6.1

* Sun Jun 17 2012 eatdirt <eatdirt> 1.6-3.mga3
+ Revision: 261190
- Add upstream patch to fix wrong path to default hostfile

* Sat Jun 16 2012 eatdirt <eatdirt> 1.6-2.mga3
+ Revision: 261000
- Moving static devel files into new sub-package. Adding missing Obsoletes.

* Thu Jun 14 2012 eatdirt <eatdirt> 1.6-1.mga3
+ Revision: 260405
- Upgrade to latest stable version 1.6

* Wed Mar 07 2012 eatdirt <eatdirt> 1.4.5-2.mga2
+ Revision: 221247
- Add missing Requires (bug 2787, also applicable to Cauldron)
- Clean files repartition in between -devel and non-devel packages

* Wed Feb 22 2012 eatdirt <eatdirt> 1.4.5-1.mga2
+ Revision: 212208
- Upgrade to latest stable (1.4.5)

* Fri Jan 13 2012 eatdirt <eatdirt> 1.4.4-1.mga2
+ Revision: 195637
- Upgrade to latest stable (1.4.4)
  Specfile cleaned and ".la" files removed

* Tue Jun 28 2011 ahmad <ahmad> 1.4.3-2.mga2
+ Revision: 115348
- Drop the buildroot declaration
- Drop old/unneeded scriptlets
- imported package openmpi

